    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * MiddlePinNeedle.java
    029     * --------------------
    030     * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * Changes:
    037     * --------
    038     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039     * 27-Mar-2003 : Implemented Serializable (DG);
    040     * 09-Sep-2003 : Added equals() method (DG);
    041     * 08-Jun-2005 : Implemented Cloneable (DG);
    042     * 22-Nov-2007 : Implemented hashCode() (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.geom.Area;
    050    import java.awt.geom.Ellipse2D;
    051    import java.awt.geom.GeneralPath;
    052    import java.awt.geom.Point2D;
    053    import java.awt.geom.Rectangle2D;
    054    import java.io.Serializable;
    055
    056    /**
    057     * A needle that is drawn as a pin shape.
    058     */
    059    public class MiddlePinNeedle extends MeterNeedle
    060                                 implements Cloneable, Serializable {
    061
    062        /** For serialization. */
    063        private static final long serialVersionUID = 6237073996403125310L;
    064
    065        /**
    066         * Draws the needle.
    067         *
    068         * @param g2  the graphics device.
    069         * @param plotArea  the plot area.
    070         * @param rotate  the rotation point.
    071         * @param angle  the angle.
    072         */
    073        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    074                                  Point2D rotate, double angle) {
    075
    076            Area shape;
    077            GeneralPath pointer = new GeneralPath();
    078
    079            int minY = (int) (plotArea.getMinY());
    080            //int maxX = (int) (plotArea.getMaxX());
    081            int maxY = (int) (plotArea.getMaxY());
    082            int midY = ((maxY - minY) / 2) + minY;
    083
    084            int midX = (int) (plotArea.getMinX() + (plotArea.getWidth() / 2));
    085            //int midY = (int) (plotArea.getMinY() + (plotArea.getHeight() / 2));
    086            int lenX = (int) (plotArea.getWidth() / 10);
    087            if (lenX < 2) {
    088                lenX = 2;
    089            }
    090
    091            pointer.moveTo(midX - lenX, midY - lenX);
    092            pointer.lineTo(midX + lenX, midY - lenX);
    093            pointer.lineTo(midX, minY);
    094            pointer.closePath();
    095
    096            lenX = 4 * lenX;
    097            Ellipse2D circle = new Ellipse2D.Double(midX - lenX / 2,
    098                                                    midY - lenX, lenX, lenX);
    099
    100            shape = new Area(circle);
    101            shape.add(new Area(pointer));
    102            if ((rotate != null) && (angle != 0)) {
    103                /// we have rotation
    104                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    105                shape.transform(getTransform());
    106            }
    107
    108            defaultDisplay(g2, shape);
    109
    110        }
    111
    112        /**
    113         * Tests another object for equality with this object.
    114         *
    115         * @param object  the object to test.
    116         *
    117         * @return A boolean.
    118         */
    119        public boolean equals(Object object) {
    120            if (object == null) {
    121                return false;
    122            }
    123            if (object == this) {
    124                return true;
    125            }
    126            if (super.equals(object) && object instanceof MiddlePinNeedle) {
    127                return true;
    128            }
    129            return false;
    130        }
    131
    132        /**
    133         * Returns a hash code for this instance.
    134         *
    135         * @return A hash code.
    136         */
    137        public int hashCode() {
    138            return super.hashCode();
    139        }
    140
    141        /**
    142         * Returns a clone of this needle.
    143         *
    144         * @return A clone.
    145         *
    146         * @throws CloneNotSupportedException if the <code>MiddlePinNeedle</code>
    147         *     cannot be cloned (in theory, this should not happen).
    148         */
    149        public Object clone() throws CloneNotSupportedException {
    150            return super.clone();
    151        }
    152
    153    }